#include <stdio.h>

void append(char *destination, char *addendum);

int main(int argc, char *argv[])
  {
    char *tfile;
    
    if (argc != 3)
      {
        fprintf(stderr,
          "Usage: %s <file-1> <file-2>\n", argv[0]);
        return 1;
      }

    /* obtain a unique name for a temporary file */
    tfile = tmpnam(NULL);

    /* create and copy the first file to the temporary file */
    append(tfile, argv[1]);
    /* append the second file to the temporary file */
    append(tfile, argv[2]);

    /* remove the first file */
    remove(argv[1]);
    /* rename the temporary file as the first file */
    rename(tfile, argv[1]);

    return 0;
}

void append(char *fn1, char *fn2)
  {
    FILE *fp1, *fp2;
    int c;

    /* open the first file in the append mode */
    fp1 = fopen(fn1, "a");
    /* open the second file in the read mode */
    fp2 = fopen(fn2, "r");

    /* append */
    while ((c = getc(fp2)) != EOF)  putc(c, fp1);

    fclose(fp1); fclose(fp2);
  }
