#include <stdio.h>

#define  MARKUP     0.2  /* 20% over cost */
#define  WHOLESALE  0.5  /* wholesale is 50% of list price */
#define  SURCHARGE  0.1  /* 10% surcharge on imported models */

int main(void)
  {
    float base_price;/* list price of the basic configuration */
    float options;   /* list price of the options */
    int imported;/* nonzero value implies an imported model */
    float lowest_price(float, float, int);

    scanf("%f %f %d",
           &base_price, &options, &imported);
    printf("Lowest Price = %f",
           lowest_price(base_price, options, imported));
    return 0;
  }

float lowest_price(float base_price,
                   float options, int imported)
  {
    float dealer_cost(float base_price,
                      float options, int imported);

    return (1 + MARKUP) *
           dealer_cost(base_price, options, imported);
  }

float dealer_cost(float base_price,
                  float options, int imported)
  {
    float base_cost, options_cost;

    base_cost = imported ?
        (1 + SURCHARGE) * WHOLESALE * base_price :
        WHOLESALE * base_price;
    options_cost = WHOLESALE * options;

    return base_cost + options_cost;
  }
