#include <stdio.h>

#define  MARKUP     0.2  /* 20% over cost */
#define  WHOLESALE  0.5  /* wholesale is 50% of list price */
#define  SURCHARGE  0.1  /* 10% surcharge on imported models */

/* external variables */
float base_price;/* list price of the basic configuration */
float options;   /* list price of the options */
int   imported;  /* nonzero value implies an imported model */

/* function prototypes */
float lowest_price(void);
float dealer_cost(void);

int main(void)
  {
    scanf("%f %f %d",
           &base_price, &options, &imported);
    printf("Lowest Price = %f\n", lowest_price());
    return 0;
  }

float lowest_price(void)
  {
    return (1 + MARKUP) * dealer_cost();
  }

float dealer_cost(void)
  {
    float base_cost, options_cost;

    base_cost = (imported) ?
        (1 + SURCHARGE) * WHOLESALE * base_price :
        WHOLESALE * base_price;
    options_cost = WHOLESALE * options;
    return base_cost + options_cost;
  }
