#include <stdio.h>
#define  MULTIPLIER  25173
#define  INCREMENT   13849
#define  MODULUS     65536
#define  SEED        21973
#define  KITTY       10000
#define  GAMES       10000

/* returns 2 if both coins have a head;
   returns 1 if one coin has a head and the other a tail;
   returns 0 if both coins have a tail */
int    play(void);

/* returns the outcome of one toss: 'H' (head) or 'T' (tail) */
char   toss(void);

/* pseudo-random number generator */
double rand(unsigned int seed0);  /* pseudo-random number generator */

int main(void)
  {
    int i, heads, balance;

    for (i = 1, balance = KITTY; i <= GAMES; i++)
      {
        heads = play();
        if (heads == 1) /* toss again */
             heads = play();
        heads == 2 ? balance++ : balance --;
      }
   
    printf("kitty = %d; take home = %d\n",
            KITTY, balance);
    return 0;
  }

int play(void)
  {
    char flip1, flip2;

    flip1 = toss();
    flip2 = toss();

    if (flip1 == 'H' && flip2 == 'H')  return 2;
    if (flip1 == 'T' && flip2 == 'T')  return 0;
    return 1;
  }

char toss(void)
  {
    return  rand(SEED) < 0.5 ? 'H' : 'T';
  }
  

double rand(unsigned int seed0)
  {
    static unsigned int number;
    static int initialized = 0;

    if (!initialized)
      {
        number = seed0 % MODULUS;
        initialized = 1;
      }

    number = (MULTIPLIER * number + INCREMENT)
              % MODULUS;
    return (double) number / (MODULUS - 1);
  }
