#include <stdio.h>
#define  ITEMS      1000
#define  NOT_FOUND  -1
#define  MAXINT     0x7fffffff

int  bld_database(int *item, float *price,
                  int total_items);
int  bsearch(int value, int *arr, int max_items);
int  lsearch(int value, int *arr, int max_items);
void find_price(int (*search)(int, int *, int),
                int item_no, int *item,
                float *price, int total_items);

int main(void)
  {
    int    item[ITEMS], item_no, sorted;
    float  price[ITEMS];

    /* build the item-price database */

    sorted = bld_database(item, price, ITEMS);

    /* read the item_no of the item whose price is to be found */

    scanf("%d", &item_no);

    /* print price */

    find_price(sorted ? bsearch : lsearch,
               item_no, item, price, ITEMS);
    return 0;
  }

int  bld_database(int *item, float *price,
                  int total_items)
  {
    int i, last = MAXINT, sorted = 1;

    for (i = 0; i < total_items; i++)
      {
        scanf("%d %f", item+i, price+i);
        if (last < *(item+i)) sorted = 0;
        last = *(item+i);
      }

    return sorted;
  }

void find_price(int (*search)(int, int *, int),
                int item_no, int *item,
                float *price, int total_items)
  {
    int index;

    index = (*search)(item_no, item, total_items);

    if (index == NOT_FOUND)
        printf("item %d is not in the database\n",
                item_no);
    else
        printf("price of item %d = %f\n",
                item_no, price[index]);
  }

/* binary search */
int bsearch(int val, int *arr, int length)
  {
    int first = 0, last = length-1, mid;

    while ( first <= last)
      {
        mid = (first + last) / 2;

        if (val == *(arr+mid))    /* search succeeds */
            return mid;
        else if (val > *(arr+mid))/* search lower half */
            last = mid - 1;
        else                      /* search upper half */
            first = mid + 1;
      }

    return NOT_FOUND;
  }

/* linear search */
int lsearch(int val, int *arr, int length)
  {
    int i;

    for (i = 0; i < length; i++)
        if (*(arr+i) == val) return i;

    return NOT_FOUND;
  }
