/*
 *  all linked-list functions in one
 */

#include <stdio.h>
#include <stdlib.h>

struct node
  {
    int data;
    struct node *next;
  };

struct node *mknode(int data)
  {
    struct node *np;

    np = (struct node *) malloc(sizeof(struct node));
    if (np)
      {
        np->data = data;
        np->next = NULL;
      }
    return np;
  }

struct node *insert(struct node **list, int data)
  {
    struct node *np;

    if (np = mknode(data))
      {
        struct node *curr = *list, *prev = NULL;

        /* locate the position of this node in the list */
        for ( ; curr && data < curr->data;
                curr = curr->next) prev = curr;

        /* let this node point to the node next in the list */
        np->next = curr;

        /* let the previous node in the list point to this node */
        if (prev)
            prev->next = np;
        else
            *list = np;  /* this node is the first in the list */
      }
    return np;
  }

void print(struct node *list)
  {
    for ( ; list; list = list->next)
        printf("%d ", list->data);
    printf("\n");
  }

void sort(void)
  {
    struct node *list = NULL;
    int i;

    while (scanf("%d", &i) != EOF &&
           insert(&list, i)) /* build list */
               ;
    print(list);
  }

int main(void)
  {
	sort();
    return 0;
  }
