/*
 *  all tree functions in one
 */

#include <stdio.h>
#include <stdlib.h>

struct node
  {
    char data;
    struct node *lchild;
    struct node *rchild;
  };

struct node *mktree(void)
  {
    int c;
    struct node *np;

    c = getchar();
    if (c != '-')
      {
        np = (struct node *)malloc(sizeof(struct node));
        np->data = c;
        np->lchild = mktree(); /* build left subtree */
        np->rchild = mktree(); /* build right subtree */
        return np;
      }
    else
        return NULL;
  }

void postorder(struct node *parent)
  {
    if (parent)
      {
        postorder(parent->lchild); /* traverse left subtree */
        postorder(parent->rchild); /* traverse right subtree */
        printf("%c", parent->data);
      }
  }

void transform(void)
  {
    struct node *root;

    root = mktree();
    postorder(root);
  }

int main(void)
  {
    transform();
    return 0;
  }
