/*
 *  determine the number of bits in an integer
 */
int intlen(void)
  {
    unsigned int intnum = ~0, bitcnt = 1;
 
    while (intnum <<= 1) bitcnt++;
    return bitcnt;
  }

/*
 *  extract at most nbits bits to the left of and including the bit
 *  at position pos and return them right-adjusted
 */
int getbits(int word, int pos, int nbits)
  {
    int intbits = intlen();

    if (pos >= intbits)/* return the word unchanged */
        return word;
    if (pos + nbits >= intbits)
        nbits = intbits - pos;/* bits to the left of pos */
    if (nbits == intbits)/* pos = 0 and nbits @>=@ \*(Cwintlen */
        return word;
    word >>= pos;/* right adjust */
    word &= ~(~0 << nbits);/* clear off other bits */
    return word;
  }

/*
 *  rotate word to the right by nbits bit positions
 */
int rrotate(int word, int nbits)
  {
    int rbits;

    if (nbits %= intlen())
      {
        /* get nbits rightmost bits */
        rbits = getbits(word, 0, nbits);
        /* shift to right by nbits positions */
        word >>= nbits;
        /* clear the propagated sign bits */
        word &= ~ (unsigned) 0 >> nbits;
        /* put back the saved bits */
        word |= rbits << (intlen() - nbits);
      }
    return word;
  }
